<template>
  <section class="stream">
    <EditFavorite @input="createConfig"/>

    <div class="container">
      <Searchbar @input="search" v-model="searchValue"/>
    </div>

    <div class="container">

      <div class="stream-header" v-if="tops.length">
        <h2>Breaking News</h2>
      </div>
      <div class="stream-wrapper -top" v-if="tops.length">
        <div class="left">
          <Article v-for="(n, index) in tops.slice(0, 2)" :news="n" :key="`${index}-top1`"/>
        </div>
        <div class="right">
          <Article v-for="(n, index) in tops.slice(2)" :news="n" :key="`${index}-top2`"/>
        </div>
      </div>


      <div class="stream-header">
        <h2>Articles</h2>
      </div>
      <div class="stream-wrapper">
        <div class="left">
          <ArticleBig v-for="(n, index) in stream.slice(0, 1)" :news="n" :key="`${index}-medium1`"/>
        </div>
        <div class="right">
          <Article v-for="(n, index) in stream.slice(1)" :news="n" :key="`${index}-medium2`"/>
        </div>
      </div>
      <div class="stream-empty" v-if="!stream.length">
        <p>No Articles. Try another search value.</p>
      </div>
    </div>
  </section>
</template>

<script>
import Icon from "@/components/Icon";
import Searchbar from "@/components/Searchbar";
import Article from "@/components/Article";
import ArticleBig from "@/components/articles/ArticleBig";
import EditFavorite from "@/components/EditFavorite";

export default {
  middleware: ['auth'],
  components: {EditFavorite, ArticleBig, Article, Searchbar, Icon},
  data() {
    return {
      newsCount: 0
    }
  },
  computed: {
    stream() {
      return this.$store.getters['Stream/stream'];
    },
    tops() {
      return this.$store.getters['Stream/tops'];
    }
  },
  async asyncData({store, $rest}) {
    await store.dispatch('Stream/reset');
    let subscriptions = await $rest.Me.config.get();
    store.commit('Stream/UPDATE_SUBSCRIPTIONS', subscriptions);

    return {
      searchValue: ''
    }
  },
  methods: {
    async search(searchValue) {
      this.searchValue = searchValue;
      await this.$store.dispatch('Stream/fetchStream', {  // fetch stream
        axios: this.$axios,
        searchValue
      });
    },

    async createConfig(data) {
      const subscriptions = await this.$rest.Me.config.set({
        id: null,
        name: data.favName,
        searchValue: this.searchValue
      });

      this.$store.commit('Stream/UPDATE_SUBSCRIPTIONS', subscriptions);
    }
  }
}
</script>

<style lang="scss">
.stream {
  --gap-article: 15px;

  position: relative;

  .container {
    @include _containerHelper('normal');
  }

  .edit-favorite {
    margin-bottom: 3vh;
  }

  .stream-header {
    margin: $grid-gap*2 0 $grid-gap 0;
    padding-bottom: 3px;
    border-bottom: 1px solid color-gray(2);

    .amount {
      @include _font-paragraph('regular', $color-subline);
      @include _font-size($font-size-s);
    }

    h2 {
      @include _font-size($font-size-3);
    }
  }

  .stream-wrapper {
    margin: 0 0 $grid-gap 0;

    @include _respond-to('desktops') {
      @include _display-flex(flex, flex-start, flex-start, row);
      @include _list-child-margin(var(--gap-article), '*', 'right');

      &.-top > *:first-child {
        flex: 0 0 58%
      }
    }

    @include _respond-to('phones') {
      .left {
        padding-bottom: var(--gap-article);
        border-bottom: 1px solid color-gray(2);
        margin-bottom: var(--gap-article);
      }
    }


    > * {
      flex: 1;
      @include _list-child-margin(var(--gap-article), '*', 'bottom');
    }

    .right {
      > * {
        padding-bottom: var(--gap-article);
        border-bottom: 1px solid color-gray(2);

        &:last-child {
          border: none;
        }
      }
    }
  }

  .stream-empty {
    position: relative;
    width: 100%;

    p {
      text-align: center;
      @include _font-paragraph('regular', color-gray(4));
    }
  }
}
</style>
